//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Timer.h
//  wb_[t@C
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//  2011/12/12 Modify for All Model  Taishi(Ver 1.03A) 
//*****************************************

#if	0
#if		CPU_CLOCK == 20								// 20MHz
  // Xtal:20MHz
  #define		COUNT_10MS		195					// 10mS at 20MHz/1024(19531.25Hz) vZ195.3125
  #define		COUNT_1MS		2500				// 1mS at 20MHz/8(2,5MHz)
#else
  #if	CPU_CLOCK == 18								// 18.432MHz
	// Xtal:18.432MHz
	#define		COUNT_10MS		180 				// 10mS at 18.432MHz/1024(18000Hz) vZ180
    #define		COUNT_1MS		2304				// 1mS at 18.432MHz/8(2.304MHz)
  #else
    #if	CPU_CLOCK == 16								// 16MHz
	  // Xtal:16MHz
	  #define	COUNT_10MS		156					// 10mS at 16MHz/1024(15625Hz) vZ156.25
      #define	COUNT_1MS		2000				// 1mS at 16MHz/8(2MHz)
    #else
	  // Xtal:8MHz									// 8MHz
	  #define	COUNT_10MS		78					// 10mS at 8MHz/1024(7812.5Hz) vZ78.125
      #define	COUNT_1MS		1000				// 1mS at 8MHz/8(1MHz)
    #endif
  #endif
#endif
#endif

// ************************************************************************
// ********** uU[̎g߂lisO̐ݒ肷j **********
// ************************************************************************
#if		CPU_CLOCK == 20								// 20MHz
  #define		KHz_4		((unsigned char)((20000000L/64L)/4000L))		// 4kHz
#else
  #if	CPU_CLOCK == 18								// 18.432MHz
    #define		KHz_4		((unsigned char)((18432000L/64L)/4000L))		// 4kHz
  #else
    #if	CPU_CLOCK == 16								// 16MHz
      #define	KHz_4		((unsigned char)((16000000L/64L)/4000L))		// 4kHz
    #else											// 8MHz
      #define	KHz_4		((unsigned char)((8000000L/64L)/4000L))			// 4kHz
    #endif
  #endif
#endif
// **** Wlg̒l ****
#define		KHz_7R8		16							// 7,8kHz
#define		KHz_5		25							// 5kHz
//#define		KHz_4		31						// 4kHz ̒l͏ŊeNbNɌ߂Ă
#define		KHz_2		62							// 2kHz
#define		KHz_1		125							// 1kHz
#define		KHz_0R49	255							// 490Hz


// **********************************************************
// ************************ Timer 2 *************************
// **********************************************************
#if		CPU_CLOCK == 20														// 20MHz
  #define			COUNT_1MS	156											// 1mS at 20MHz/128 = 156.250kHz(6.4uS)
  #define			D_TCCR2B	((1 << CS22) | (0 << CS21) | (1 << CS20))	// Timer Start (20MHz/128= 156.250kHz, 6.4uS)
#else
  #if	CPU_CLOCK == 18														// 18.432MHz
    #define			COUNT_1MS	144											// 1mS at 18.432MHz/128 = 144kHz(6.94uS)
    #define			D_TCCR2B	((1 << CS22) | (0 << CS21) | (1 << CS20))	// Timer Start (18.432MHz/128= 144kHz, 6.94uS)
  #else
    #if	CPU_CLOCK == 16														// 16MHz
      #define		COUNT_1MS	250											// 1mS at 16MHz/64 = 250kHz(4uS)
      #define		D_TCCR2B	((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (16MHz/64= 250kHz, 4uS)
    #else																	// 8MHz
      #define		COUNT_1MS		125										// 1mS at 8MHz/64 = 125kHz(8uS)
      #define		D_TCCR2B	((1 << CS22) | (0 << CS21) | (0 << CS20))	// Timer Start (8MHz/64= 125kHz, 8uS)
    #endif
  #endif
#endif


extern	unsigned char	tim_1ms;						// 10mSPʂJE^[
extern	unsigned char	tim_10ms;						// PbPʂJE^[
extern	unsigned char	tim_10ms_led;					// kdcpPOrPʃ^C}[
extern	unsigned char	tim_10ms_buz;					// uU[pPOrPʃ^C}[
extern	unsigned char	tim_10ms_sw;					// XCb`͗pPOrPʃ^C}[
extern	unsigned char	tim_10ms_battery;				// obeuNpPOrPʃ^C}[
extern	unsigned int	hv_out;
extern	unsigned int	hv_target_volt;
extern	unsigned int	hv_moni;						// g@uiunksPʁj
extern	unsigned int	bat_moni;						// obe@uiODOPuPʁj
extern	unsigned char	tim_10ms_battery_zero_now;		// obeuNp̃^C}[OɂȂ
extern	unsigned char	tim2_1s_flg;					// qsbĂȂ̂Pboߗp


extern	volatile unsigned char	tim_led;						// kdc_p^C}[iPOrPʁj
extern	volatile unsigned char	tim_sw;							// XCb`͗p^C}[iPOrPʁj
extern	volatile unsigned int	tim_disp;						// Mf[^\Ԋup^C}[iPOrPʁj
extern	volatile unsigned int	tim_run_led;					// Mf[^擾kdc_ŗp^C}[iPOrPʁj

extern	void	delay_1us(unsigned char t);
extern	void	delay_2us(unsigned char t);
extern	void	delay_ms(int tm);
extern	void	Timer2_init(void);
extern	void	Timer1_init(unsigned char ei);
extern	void	Timer0_init(void);
extern	void	buz2_on_off(unsigned char on_off);
extern	void	buz2_on_off_sp(unsigned char on_off, unsigned char syuki);
extern	void	HV_on(void);
extern	void	HV_off(void);
extern	void	set_Timer1_ontime(void);
extern	void	read_hv_target_volt(unsigned char ei);		// gu@o͒l̓ǂݏo
