//*****************************************
// AVR ATmega644P Geiger Counter
// CPU Clock:8MHz,16NHz,18.432MHz or 20MHz(Compile Option)
// File Name:Utility.c
// KCK[JE^[p
//   iq[Yf[^@is`fgpȂAȂAwIV[^(8MHz)Aɂj
//   i`FbN͂rohdmj
//
//  2011/09/02 New  Taishi ATmega644P(J308)
//  2011/10/22 Modify for LND712 by  Taishi
//  2011/10/28 Modify for SBM-20 by  Taishi
//  2011/11/08 Modify for LND712 by  Taishi
//  2011/11/12 Modify for SBM-20 by  Taishi
//  2011/11/12 Modify for J-308  by  Taishi
//  2011/11/24 Modify for All Model  Taishi
//*****************************************
#include				<avr/interrupt.h>
#include				<avr/io.h>
#include				<avr/pgmspace.h>


#include				"AVR_ATmega644_Geiger.h"
#include				"Serial.h"
#include				"LCD.h"

#include				"Utility.h"
#include				"Timer.h"

unsigned char			sw[3];							// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏
unsigned char			old_sw;


/****************************************************************/
/* PoCgf[^										*/
/* PUîQ̂`rbhhɕϊ							*/
/* ʌ̂OTvX͂Ȃ									*/
/****************************************************************/
void	wtod_02x(char *bf,unsigned char ucd)
{
	*bf = (char)(((ucd>>4) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf=0;
}
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_02u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}
/****************************************/
/* PoCgf[^				*/
/* Q̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_2u(char *bf,unsigned char ucd)
{
	*bf = (char)('0'+(ucd/10));
	if(*bf == '0'){
		*bf = ' ';
	}
	bf++;
	*bf = (char)('0'+(ucd%10));
	bf++;
	*bf=0;
}

/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_05u(char *bf,unsigned int usd)
{
	int				i;
	unsigned int	cui;

	cui = 10000;
	for(i=0;i<5;i++){
		*bf = (char)('0'+(usd/cui));
		usd %= cui;
		bf++;
		cui /= 10;
	}
	*bf=0;
}
/****************************************/
/* QoCgf[^				*/
/* T̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_5u(char *bf,unsigned int usd)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_05u(bf, usd);					// QoCgf[^T̂POî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<4;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}

/****************************************/
/* SoCgf[^				*/
/* V̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/* V𒴂鎞͂XXXXXXXɂ	*/
/****************************************/
void	wtod_07u(char *bf,unsigned long uld)
{
	unsigned int	i;
	unsigned long	cul;

	cul = 1000000;
	if( (unsigned long)9 < (uld / cul) ){
		for(i=0;i<7;i++){
			*bf = (char)'9';
			bf++;
		}
	}else{
		for(i=0;i<7;i++){
			*bf = (char)('0'+(uld/cul));
			uld %= cul;
			bf++;
			cul /= 10;
		}
	}
	*bf=0;
}
/********************************************/
/* SoCgf[^					*/
/* PÔPOî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ				*/
/********************************************/
void	wtod_010u(char *bf,unsigned long uld)
{
	unsigned char	i;
	unsigned long	cul;

	cul = 1000000000;
	for(i=0;i<10;i++){
		*bf = (char)('0'+(uld/cul));
		uld %= cul;
		bf++;
		cul /= 10L;
	}
	*bf=0;
}
/****************************************/
/* SoCgf[^				*/
/* V̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_7u(char *bf,unsigned long uld)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_07u(bf, uld);					// SoCgf[^V̂POî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<6;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}
/****************************************/
/* SoCgf[^				*/
/* V̂POî`rbhhɕϊ	*/
/* ʌ̂OTvXōlɂ		*/
/****************************************/
void	wtod_l7u(char *bf,unsigned long uld)
{
	int				i;
	char			*bfb;
	char			mm[10];

	bfb = &mm[0];
	wtod_07u(mm, uld);					// SoCgf[^V̂POî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<6;i++,bfb++){
		if(*bfb == '0'){
			;
		}else{
			break;
		}
	}
	llstrcpy(bf,bfb);
}
/****************************************/
/* SoCgf[^				*/
/* PÔPOî`rbhhɕϊ	*/
/* ʌ̂OTvX				*/
/****************************************/
void	wtod_10u(char *bf,unsigned long uld)
{
	int				i;
	char			*bfb;

	bfb = bf;
	wtod_010u(bf, uld);					// SoCgf[^PÔPOî`rbhhɕϊ(ʌ̂OTvX͂Ȃ)
	for(i=0;i<9;i++,bfb++){
		if(*bfb == '0'){
			*bfb = ' ';
		}else{
			break;
		}
	}
}

/****************************************/
/* QoCgf[^				*/
/* ŜPUî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_04x(char *bf,unsigned int ucd)
{
	*bf = (char)(((ucd>>12) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd>>8) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd>>4) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf = (char)(((ucd) & 0x0f)|'0');
	if (*bf > '9'){
		*bf += 7;
	}
	bf++;
	*bf=0;
}
/****************************************/
/* QoCgf[^				*/
/* R̂POî`rbhhɕϊ	*/
/* ʌ̂OTvX͂Ȃ			*/
/****************************************/
void	wtod_03u(char *bf,unsigned int ucd)
{
	ucd %= 1000;

	*bf = (char)('0'+(ucd/100));
	ucd %= 100;
	bf++;

	*bf = (char)('0'+(ucd/10));
	bf++;

	*bf = (char)('0'+(ucd%10));
	bf++;

	*bf=0;
}
/********************************/
/* ̎w蕶̃Rs[	*/
/*@߂ĺ@Ȃ				*/
/********************************/
void	llstrncpy(char *b1,char *b2,short n)
{
	short	i;

	for(i=0;i<n;i++){
		*b1 = *b2;
		b1++;
		b2++;
	}
}
/************************/
/* ̃Rs[		*/
/*@߂ĺ@Ȃ		*/
/************************/
void	llstrcpy(char *b1,char *b2)
{
	while(*b2 != 0){
		*b1 = *b2;
		b1++;
		b2++;
	}
	*b1=0;
}


//***************************
//@XCb`Ԃ
// SW[1] Ɍ݂̏ԁAĂ镨'1'̏
// SW[2] ɉꂽuԂ'1'̏
//  Timer1 ̊荞݂gpĂԂKv
//***************************
void	get_sw(void)
{
	unsigned char	uc;

	if(tim_10ms_sw == 0){
		tim_10ms_sw = 3;									// ROrԊu
		uc = ((~PIND) & (SW_LEFT | SW_RIGHT));				// ]ăXCb`f[^擾
		if (old_sw == uc){									// OƓf[^̎
			sw[0] = sw[1];
			sw[1] = uc;
			sw[2] = ((sw[0] ^ sw[1]) & sw[1]);				// ꂽXCb`f[^
		}else{
			sw[2] = 0;
		}
		old_sw = uc;										// Of[^ɓ
	}else{
		sw[2] = 0;
	}
}

//***************************
//@XCb`֌W̏ݒ
//***************************
void	sw_init(void)
{
#ifdef		PD5_DEBUG_OUT
	DDRD &= ~( (1 << DDD6) | (1 << DDD7) );					// Port-D Bit6,7 : Intput
	PORTD |= ( (1 << PD6) | (1 << PD7) );					// Port-D Bit6,7 : Pullup
#else		//PD5_DEBUG_OUT
	DDRD &= ~( (1 << DDD5) | (1 << DDD6) | (1 << DDD7) );	// Port-D Bit5,6,7 : Intput
	PORTD |= ( (1 << PD5) | (1 << PD6) | (1 << PD7) );		// Port-D Bit5,6,7 : Pullup
#endif		//PD5_DEBUG_OUT
}

//*****************************************
// vÖ̕擾
// 	őQO܂
//  擾 disp_moji[] ɓ
//*****************************************
void	get_pgm_str(unsigned char *puc)
{
	unsigned char i;
	unsigned char uc;

	for(i=0; i < 20 ; i++){
		uc = pgm_read_byte(puc + i);
		if(uc == 0){									// ^[~l[^[̎
			break;
		}
		disp_moji[i] = pgm_read_byte(puc + i);
	}
	disp_moji[i] = 0;
}

